# vim:ts=4 sw=4
# ----------------------------------------------------------------------------------------------------
#  Name		: ETL::Pequel3::Catalogue.pm
#  Created	: 21 June 2006
#  Author	: Mario Gaffiero (gaffie)
#
# Copyright 1999-2007 Mario Gaffiero.
# 
# This file is part of Pequel(TM).
# 
# Pequel is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
# 
# Pequel is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with Pequel; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
# ----------------------------------------------------------------------------------------------------
# Modification History
# When          Version     Who     What
# ----------------------------------------------------------------------------------------------------
package ETL::Pequel3::Catalogue;
require 5.005_62;
use strict;
use warnings;
use stl;
use ETL::Pequel3::Type::Catalogue;
# ----------------------------------------------------------------------------------------------------
{
	package ETL::Pequel3::Catalogue;
	use base qw(ETL::Pequel3::Type::Catalogue);
	use Class::STL::ClassMembers
		Class::STL::ClassMembers::DataMember->new(name => 'catalogue_name', default => 'main'),
		Class::STL::ClassMembers::DataMember->new(name => 'target_mem_name', default => 'catalogue_name'),
		Class::STL::ClassMembers::DataMember->new(name => 'element_type', default => 'ETL::Pequel3::Type::Catalogue');
	use Class::STL::ClassMembers::SingletonConstructor;
	sub new_extra
	{
		my $self = shift;
		use ETL::Pequel3::Type::DataSet;
		use ETL::Pequel3::Type::DataSource;
		use ETL::Pequel3::Type::Properties;
		use ETL::Pequel3::Type::Aggregates;
		use ETL::Pequel3::Type::Macros;
		use ETL::Pequel3::Type::Months;
		use ETL::Pequel3::Type::Table;
		use ETL::Pequel3::Type::Sorters;
		use ETL::Pequel3::Type::FieldSet;
		use ETL::Pequel3::Type::Section::Catalogue;
		use ETL::Pequel3::Generator;
		use ETL::Pequel3::DocGen;
		use ETL::Pequel3::CatGen;
		use ETL::Pequel3::Type::XmlParser;
		use ETL::Pequel3::Type::CmdOption;
		use ETL::Pequel3::SchemaGen;
		use ETL::Pequel3::Type::Document;
		$self->push_back(
			ETL::Pequel3::Type::DataSource::Input::Catalogue->new(),
			ETL::Pequel3::Type::DataSource::Output::Catalogue->new(),
			ETL::Pequel3::Type::DataSet::Input::Catalogue->new(),
			ETL::Pequel3::Type::DataSet::Output::Catalogue->new(),
			ETL::Pequel3::Type::Properties->new(),
			ETL::Pequel3::Type::Section::Catalogue->new(),
			ETL::Pequel3::Type::Aggregates::Catalogue->new(),
			ETL::Pequel3::Type::Macros::Catalogue->new(),
			ETL::Pequel3::Type::Macros::Category::Catalogue->new(),
			ETL::Pequel3::Type::PequelTypes::Catalogue->new(),
			ETL::Pequel3::Type::Dates::Catalogue->new(),
			ETL::Pequel3::Type::Months::Catalogue->new(),
			ETL::Pequel3::Type::Table::Catalogue->new(),
			ETL::Pequel3::Type::FieldSet::Catalogue->new(),
			ETL::Pequel3::DocGen::Chapter::Catalogue->new(),
			ETL::Pequel3::CatGen::Chapter::Catalogue->new(),
			ETL::Pequel3::Generator::Segment::Catalogue->new(),
			ETL::Pequel3::Generator::Catalogue->new(),
			ETL::Pequel3::Type::Sorters::Catalogue->new(),
			ETL::Pequel3::Type::XmlParser::Catalogue->new(),
			ETL::Pequel3::Type::CmdOption::Catalogue->new(),
			ETL::Pequel3::SchemaGen::Catalogue->new(),
			ETL::Pequel3::Type::Document::Catalogue->new(),
		);
		return $self;
	}
}
# ----------------------------------------------------------------------------------------------------
1;
