# vim:ts=4 sw=4
# ----------------------------------------------------------------------------------------------------
#  Name		: ETL::Pequel3::CodeStyler.pm
#  Created	: 7 July 2006
#  Author	: Mario Gaffiero (gaffie)
#
# Copyright 1999-2007 Mario Gaffiero.
# 
# This file is part of Pequel(TM).
# 
# Pequel is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
# 
# Pequel is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with Pequel; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
# ----------------------------------------------------------------------------------------------------
# Modification History
# When          Version     Who     What
# ----------------------------------------------------------------------------------------------------
package ETL::Pequel3::CodeStyler;
require 5.005_62;
use strict;
use warnings;
use Class::CodeStyler;
# ----------------------------------------------------------------------------------------------------
{
	package ETL::Pequel3::CodeStyler::Program;
	use base qw(Class::CodeStyler::Program::Abstract);
	use Class::STL::ClassMembers
		Class::STL::ClassMembers::DataMember->new(name => 'divider_length', default => 100),
		Class::STL::ClassMembers::DataMember->new(name => 'divider_char', default => '+'),
		Class::STL::ClassMembers::DataMember->new(name => 'tab_size', default => 4);
	use Class::STL::ClassMembers::Constructor; 
}
# ----------------------------------------------------------------------------------------------------
{
	package ETL::Pequel3::CodeStyler::Program::Perl;
	use base qw(ETL::Pequel3::CodeStyler::Program);
	use Class::STL::ClassMembers;
	use Class::STL::ClassMembers::Constructor; 
}
# ----------------------------------------------------------------------------------------------------
1;
